Index: trunk/src/VBox/Main/idl/VirtualBox.xidl
===================================================================
--- trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 39711)
+++ trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 39712)
@@ -13517,6 +13517,6 @@
     </method>
 
-    <attribute name="singlestep" type="boolean">
-      <desc>Switch for enabling singlestepping.</desc>
+    <attribute name="singleStep" type="boolean">
+      <desc>Switch for enabling single-stepping.</desc>
     </attribute>
 
Index: trunk/src/VBox/Main/include/MachineDebuggerImpl.h
===================================================================
--- trunk/src/VBox/Main/include/MachineDebuggerImpl.h	(revision 39711)
+++ trunk/src/VBox/Main/include/MachineDebuggerImpl.h	(revision 39712)
@@ -52,31 +52,31 @@
 
     // IMachineDebugger properties
-    STDMETHOD(COMGETTER(Singlestep)) (BOOL *aEnabled);
-    STDMETHOD(COMSETTER(Singlestep)) (BOOL aEnable);
-    STDMETHOD(COMGETTER(RecompileUser)) (BOOL *aEnabled);
-    STDMETHOD(COMSETTER(RecompileUser)) (BOOL aEnable);
-    STDMETHOD(COMGETTER(RecompileSupervisor)) (BOOL *aEnabled);
-    STDMETHOD(COMSETTER(RecompileSupervisor)) (BOOL aEnable);
-    STDMETHOD(COMGETTER(PATMEnabled)) (BOOL *aEnabled);
-    STDMETHOD(COMSETTER(PATMEnabled)) (BOOL aEnable);
-    STDMETHOD(COMGETTER(CSAMEnabled)) (BOOL *aEnabled);
-    STDMETHOD(COMSETTER(CSAMEnabled)) (BOOL aEnable);
-    STDMETHOD(COMGETTER(LogEnabled)) (BOOL *aEnabled);
-    STDMETHOD(COMSETTER(LogEnabled)) (BOOL aEnable);
-    STDMETHOD(COMGETTER(LogDbgFlags)) (BSTR *a_pbstrSettings);
-    STDMETHOD(COMGETTER(LogDbgGroups)) (BSTR *a_pbstrSettings);
-    STDMETHOD(COMGETTER(LogDbgDestinations)) (BSTR *a_pbstrSettings);
-    STDMETHOD(COMGETTER(LogRelFlags)) (BSTR *a_pbstrSettings);
-    STDMETHOD(COMGETTER(LogRelGroups)) (BSTR *a_pbstrSettings);
-    STDMETHOD(COMGETTER(LogRelDestinations)) (BSTR *a_pbstrSettings);
-    STDMETHOD(COMGETTER(HWVirtExEnabled)) (BOOL *aEnabled);
-    STDMETHOD(COMGETTER(HWVirtExNestedPagingEnabled)) (BOOL *aEnabled);
-    STDMETHOD(COMGETTER(HWVirtExVPIDEnabled)) (BOOL *aEnabled);
-    STDMETHOD(COMGETTER(PAEEnabled)) (BOOL *aEnabled);
+    STDMETHOD(COMGETTER(SingleStep))(BOOL *a_pfEnabled);
+    STDMETHOD(COMSETTER(SingleStep))(BOOL a_fEnable);
+    STDMETHOD(COMGETTER(RecompileUser))(BOOL *a_pfEnabled);
+    STDMETHOD(COMSETTER(RecompileUser))(BOOL a_fEnable);
+    STDMETHOD(COMGETTER(RecompileSupervisor))(BOOL *a_pfEnabled);
+    STDMETHOD(COMSETTER(RecompileSupervisor))(BOOL a_fEnable);
+    STDMETHOD(COMGETTER(PATMEnabled))(BOOL *a_pfEnabled);
+    STDMETHOD(COMSETTER(PATMEnabled))(BOOL a_fEnable);
+    STDMETHOD(COMGETTER(CSAMEnabled))(BOOL *a_pfEnabled);
+    STDMETHOD(COMSETTER(CSAMEnabled))(BOOL a_fEnable);
+    STDMETHOD(COMGETTER(LogEnabled))(BOOL *a_pfEnabled);
+    STDMETHOD(COMSETTER(LogEnabled))(BOOL a_fEnable);
+    STDMETHOD(COMGETTER(LogDbgFlags))(BSTR *a_pbstrSettings);
+    STDMETHOD(COMGETTER(LogDbgGroups))(BSTR *a_pbstrSettings);
+    STDMETHOD(COMGETTER(LogDbgDestinations))(BSTR *a_pbstrSettings);
+    STDMETHOD(COMGETTER(LogRelFlags))(BSTR *a_pbstrSettings);
+    STDMETHOD(COMGETTER(LogRelGroups))(BSTR *a_pbstrSettings);
+    STDMETHOD(COMGETTER(LogRelDestinations))(BSTR *a_pbstrSettings);
+    STDMETHOD(COMGETTER(HWVirtExEnabled))(BOOL *a_pfEnabled);
+    STDMETHOD(COMGETTER(HWVirtExNestedPagingEnabled))(BOOL *a_pfEnabled);
+    STDMETHOD(COMGETTER(HWVirtExVPIDEnabled))(BOOL *a_pfEnabled);
+    STDMETHOD(COMGETTER(PAEEnabled))(BOOL *a_pfEnabled);
     STDMETHOD(COMGETTER(OSName))(BSTR *a_pbstrName);
     STDMETHOD(COMGETTER(OSVersion))(BSTR *a_pbstrVersion);
-    STDMETHOD(COMGETTER(VirtualTimeRate)) (ULONG *aPct);
-    STDMETHOD(COMSETTER(VirtualTimeRate)) (ULONG aPct);
-    STDMETHOD(COMGETTER(VM)) (LONG64 *aVm);
+    STDMETHOD(COMGETTER(VirtualTimeRate))(ULONG *a_puPct);
+    STDMETHOD(COMSETTER(VirtualTimeRate))(ULONG a_uPct);
+    STDMETHOD(COMGETTER(VM))(LONG64 *a_u64Vm);
 
     // IMachineDebugger methods
@@ -117,7 +117,8 @@
 
     Console * const mParent;
-    // flags whether settings have been queued because
-    // they could not be sent to the VM (not up yet, etc.)
-    int mSinglestepQueued;
+    /** @name Flags whether settings have been queued because they could not be sent
+     *        to the VM (not up yet, etc.)
+     * @{ */
+    int mSingleStepQueued;
     int mRecompileUserQueued;
     int mRecompileSupervisorQueued;
@@ -127,4 +128,5 @@
     uint32_t mVirtualTimeRateQueued;
     bool mFlushMode;
+    /** @}  */
 };
 
Index: trunk/src/VBox/Main/src-client/MachineDebuggerImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/MachineDebuggerImpl.cpp	(revision 39711)
+++ trunk/src/VBox/Main/src-client/MachineDebuggerImpl.cpp	(revision 39712)
@@ -86,5 +86,5 @@
     unconst(mParent) = aParent;
 
-    mSinglestepQueued = ~0;
+    mSingleStepQueued = ~0;
     mRecompileUserQueued = ~0;
     mRecompileSupervisorQueued = ~0;
@@ -125,15 +125,24 @@
  *
  * @returns COM status code
- * @param   aEnabled address of result variable
- */
-STDMETHODIMP MachineDebugger::COMGETTER(Singlestep) (BOOL *aEnabled)
-{
-    CheckComArgOutPointerValid(aEnabled);
-
-    AutoCaller autoCaller(this);
-    if (FAILED(autoCaller.rc())) return autoCaller.rc();
-
-    /** @todo */
-    ReturnComNotImplemented();
+ * @param   a_fEnabled      Where to store the result.
+ */
+STDMETHODIMP MachineDebugger::COMGETTER(SingleStep)(BOOL *a_fEnabled)
+{
+    CheckComArgOutPointerValid(a_fEnabled);
+
+    AutoCaller autoCaller(this);
+    HRESULT hrc = autoCaller.rc();
+    if (SUCCEEDED(hrc))
+    {
+        AutoReadLock alock(this COMMA_LOCKVAL_SRC_POS);
+        Console::SafeVMPtr ptrVM(mParent);
+        hrc = ptrVM.rc();
+        if (SUCCEEDED(hrc))
+        {
+            /** @todo */
+            ReturnComNotImplemented();
+        }
+    }
+    return hrc;
 }
 
@@ -142,13 +151,22 @@
  *
  * @returns COM status code
- * @param aEnable new singlestepping flag
- */
-STDMETHODIMP MachineDebugger::COMSETTER(Singlestep) (BOOL aEnable)
-{
-    AutoCaller autoCaller(this);
-    if (FAILED(autoCaller.rc())) return autoCaller.rc();
-
-    /** @todo */
-    ReturnComNotImplemented();
+ * @param   a_fEnable       The new state.
+ */
+STDMETHODIMP MachineDebugger::COMSETTER(SingleStep)(BOOL a_fEnable)
+{
+    AutoCaller autoCaller(this);
+    HRESULT hrc = autoCaller.rc();
+    if (SUCCEEDED(hrc))
+    {
+        AutoWriteLock alock(this COMMA_LOCKVAL_SRC_POS);
+        Console::SafeVMPtr ptrVM(mParent);
+        hrc = ptrVM.rc();
+        if (SUCCEEDED(hrc))
+        {
+            /** @todo */
+            ReturnComNotImplemented();
+        }
+    }
+    return hrc;
 }
 
@@ -157,5 +175,5 @@
  *
  * @returns COM status code
- * @param   aEnabled address of result variable
+ * @param   a_fEnabled address of result variable
  */
 STDMETHODIMP MachineDebugger::COMGETTER(RecompileUser) (BOOL *aEnabled)
@@ -752,23 +770,23 @@
  *
  * @returns COM status code.
- * @param   aPct     Where to store the rate.
- */
-STDMETHODIMP MachineDebugger::COMGETTER(VirtualTimeRate) (ULONG *aPct)
-{
-    CheckComArgOutPointerValid(aPct);
-
-    AutoCaller autoCaller(this);
-    if (FAILED(autoCaller.rc())) return autoCaller.rc();
-
-    AutoReadLock alock(this COMMA_LOCKVAL_SRC_POS);
-
-    Console::SafeVMPtrQuiet pVM (mParent);
-
-    if (pVM.isOk())
-        *aPct = TMGetWarpDrive (pVM);
-    else
-        *aPct = 100;
-
-    return S_OK;
+ * @param   a_puPct      Where to store the rate.
+ */
+STDMETHODIMP MachineDebugger::COMGETTER(VirtualTimeRate)(ULONG *a_puPct)
+{
+    CheckComArgOutPointerValid(a_puPct);
+
+    AutoCaller autoCaller(this);
+    HRESULT hrc = autoCaller.rc();
+    if (SUCCEEDED(hrc))
+    {
+        AutoReadLock alock(this COMMA_LOCKVAL_SRC_POS);
+
+        Console::SafeVMPtr ptrVM(mParent);
+        hrc = ptrVM.rc();
+        if (SUCCEEDED(hrc))
+            *a_puPct = TMGetWarpDrive(ptrVM.raw());
+    }
+
+    return hrc;
 }
 
@@ -779,62 +797,64 @@
  * @param   aPct     Where to store the rate.
  */
-STDMETHODIMP MachineDebugger::COMSETTER(VirtualTimeRate) (ULONG aPct)
-{
-    if (aPct < 2 || aPct > 20000)
-        return E_INVALIDARG;
-
-    AutoCaller autoCaller(this);
-    if (FAILED(autoCaller.rc())) return autoCaller.rc();
-
-    AutoWriteLock alock(this COMMA_LOCKVAL_SRC_POS);
-
-    if (queueSettings())
-    {
-        // queue the request
-        mVirtualTimeRateQueued = aPct;
-        return S_OK;
-    }
-
-    Console::SafeVMPtr pVM(mParent);
-    if (FAILED(pVM.rc())) return pVM.rc();
-
-    int vrc = TMR3SetWarpDrive (pVM, aPct);
-    if (RT_FAILURE(vrc))
-    {
-        /** @todo handle error code. */
-    }
-
-    return S_OK;
+STDMETHODIMP MachineDebugger::COMSETTER(VirtualTimeRate)(ULONG a_uPct)
+{
+    if (a_uPct < 2 || a_uPct > 20000)
+        return setError(E_INVALIDARG, tr("%u is out of range [2..20000]"), a_uPct);
+
+    AutoCaller autoCaller(this);
+    HRESULT hrc = autoCaller.rc();
+    if (SUCCEEDED(hrc))
+    {
+        AutoWriteLock alock(this COMMA_LOCKVAL_SRC_POS);
+        if (queueSettings())
+            mVirtualTimeRateQueued = a_uPct;
+        else
+        {
+            Console::SafeVMPtr ptrVM(mParent);
+            hrc = ptrVM.rc();
+            if (SUCCEEDED(hrc))
+            {
+                int vrc = TMR3SetWarpDrive(ptrVM.raw(), a_uPct);
+                if (RT_FAILURE(vrc))
+                    hrc = setError(VBOX_E_VM_ERROR, tr("TMR3SetWarpDrive(, %u) failed with rc=%Rrc"), a_uPct, vrc);
+            }
+        }
+    }
+
+    return hrc;
 }
 
 /**
  * Hack for getting the VM handle.
+ *
  * This is only temporary (promise) while prototyping the debugger.
  *
  * @returns COM status code
- * @param   aVm      Where to store the vm handle.
- *                  Since there is no uintptr_t in COM, we're using the max integer.
- *                  (No, ULONG is not pointer sized!)
- */
-STDMETHODIMP MachineDebugger::COMGETTER(VM) (LONG64 *aVm)
-{
-    CheckComArgOutPointerValid(aVm);
-
-    AutoCaller autoCaller(this);
-    if (FAILED(autoCaller.rc())) return autoCaller.rc();
-
-    AutoReadLock alock(this COMMA_LOCKVAL_SRC_POS);
-
-    Console::SafeVMPtr pVM(mParent);
-    if (FAILED(pVM.rc())) return pVM.rc();
-
-    *aVm = (intptr_t)pVM.raw();
-
-    /*
-     *  Note: pVM protection provided by SafeVMPtr is no more effective
-     *  after we return from this method.
-     */
-
-    return S_OK;
+ * @param   a_u64Vm     Where to store the vm handle. Since there is no
+ *                      uintptr_t in COM, we're using the max integer.
+ *                      (No, ULONG is not pointer sized!)
+ */
+STDMETHODIMP MachineDebugger::COMGETTER(VM)(LONG64 *a_u64Vm)
+{
+    CheckComArgOutPointerValid(a_u64Vm);
+
+    AutoCaller autoCaller(this);
+    HRESULT hrc = autoCaller.rc();
+    if (SUCCEEDED(hrc))
+    {
+        AutoReadLock alock(this COMMA_LOCKVAL_SRC_POS);
+
+        Console::SafeVMPtr ptrVM(mParent);
+        hrc = ptrVM.rc();
+        if (SUCCEEDED(hrc))
+            *a_u64Vm = (intptr_t)ptrVM.raw();
+
+        /*
+         * Note! pVM protection provided by SafeVMPtr is no long effective
+         *       after we return from this method.
+         */
+    }
+
+    return hrc;
 }
 
@@ -1448,37 +1468,37 @@
 {
     mFlushMode = true;
-    if (mSinglestepQueued != ~0)
-    {
-        COMSETTER(Singlestep) (mSinglestepQueued);
-        mSinglestepQueued = ~0;
+    if (mSingleStepQueued != ~0)
+    {
+        COMSETTER(SingleStep)(mSingleStepQueued);
+        mSingleStepQueued = ~0;
     }
     if (mRecompileUserQueued != ~0)
     {
-        COMSETTER(RecompileUser) (mRecompileUserQueued);
+        COMSETTER(RecompileUser)(mRecompileUserQueued);
         mRecompileUserQueued = ~0;
     }
     if (mRecompileSupervisorQueued != ~0)
     {
-        COMSETTER(RecompileSupervisor) (mRecompileSupervisorQueued);
+        COMSETTER(RecompileSupervisor)(mRecompileSupervisorQueued);
         mRecompileSupervisorQueued = ~0;
     }
     if (mPatmEnabledQueued != ~0)
     {
-        COMSETTER(PATMEnabled) (mPatmEnabledQueued);
+        COMSETTER(PATMEnabled)(mPatmEnabledQueued);
         mPatmEnabledQueued = ~0;
     }
     if (mCsamEnabledQueued != ~0)
     {
-        COMSETTER(CSAMEnabled) (mCsamEnabledQueued);
+        COMSETTER(CSAMEnabled)(mCsamEnabledQueued);
         mCsamEnabledQueued = ~0;
     }
     if (mLogEnabledQueued != ~0)
     {
-        COMSETTER(LogEnabled) (mLogEnabledQueued);
+        COMSETTER(LogEnabled)(mLogEnabledQueued);
         mLogEnabledQueued = ~0;
     }
     if (mVirtualTimeRateQueued != ~(uint32_t)0)
     {
-        COMSETTER(VirtualTimeRate) (mVirtualTimeRateQueued);
+        COMSETTER(VirtualTimeRate)(mVirtualTimeRateQueued);
         mVirtualTimeRateQueued = ~0;
     }
@@ -1495,5 +1515,5 @@
         // check if the machine is running
         MachineState_T machineState;
-        mParent->COMGETTER(State) (&machineState);
+        mParent->COMGETTER(State)(&machineState);
         switch (machineState)
         {